// C Source File
// Created 4/19/01; 5:45:49 PM

//#define DEBUG
#define OPTIMIZE_ROM_CALLS
#include <link.h>
#include "LinkLib.h"

//////////////////////////////////////////////////////////////////////////
//generic screen dump: asks for and recieves a screen dump from a calc //
////////////////////////////////////////////////////////////////////////
short GetScreenDump(unsigned char DeviceID, unsigned char* scrbuff, int scrsize)
{
	LinkPacket p;
	unsigned int checksum;
	
//send the screen dump command packet
	SendLinkCommand(DeviceID,LNK_SCR);
	
	if(LIO_RecvData(p.packet,4,LNK_TIMEOUT))	//get the response packet
		return FALSE;	//an error occured

//the recieved packet should be LNK_ACK
	if(p.extended.cmd!=LNK_ACK)
		return FALSE;

//recieve the screen dump
	if(LIO_RecvData(scrbuff,scrsize,LNK_TIMEOUT))
		return FALSE;	

//recieve the checksum
	if(LIO_RecvData(&checksum,2,LNK_TIMEOUT))
		return FALSE;

//verify the checksum if bad just return;
		if(checksum!=Checksum(scrbuff,scrsize))
			//could send LNK_ERR and try to get it again here...
			return FALSE;

//Tell the sending calc that the screen dump was recieved OK.
	SendLinkCommand(DeviceID,LNK_ACK);
	
	return TRUE;

}

